#!/bin/awk
#   Script : QAI.awk
#   Author : Richard A. O'Keefe
#   Updated: February 2013
#   Purpose: Question-Answer Interpreter

BEGIN {
    right = 0
    wrong = 0
}

/^Q / {
    print substr($0, 3)
    position = 0
    expect = ""
    next
}

/^[DAFT] / {
    position++
    label = substr("ABCDEFGHIJKLMNOPQRSTUVWXYZ", position, 1)
    print "(" label ") " substr($0, 3)
    if ($0 ~ /^[AT]/) expect = expect label
    next
}

/^E/ {
    getline answer <"/dev/tty"
    gsub(/[^A-Za-z]+/, "", answer)
    if (toupper(answer) == expect) {
        print "Correct."
        right++
    } else {    
        print "Sorry, the right answer is " expect "."
        wrong++
    }
    print ""
    next
}

/^[^QDAFTER]/ {
    printf "Oh dear, there is an error at line %d of the script %s.\n" \
           "This is our fault, not yours.\n<%s>\n", FNR, FILENAME, $0  \
           >"/dev/stderr"
    exit 1
}

END {
    print "You got", right, "questions right out of", right+wrong
    if (wrong == 0) print "Congratulations!"
}
